install.packages("deldir")
install.packages("magic")
install.packages("geometry")
install.packages("spatstat")
install.packages("rgdal")
install.packages("tripack")

library(deldir)
library(magic)
library(geometry)
library(spatstat)
library(rgdal)
library(tripack)

lambda = 4

M=2*lambda

N1 <- 2 # Choose N1=10 for Figures 6, 7, 8
N2 <- 5 # Choose N1=100 for Figures 6, 7, 8

N2 <- 100 

P1 <- matrix(0,M+1) 
V1 <- matrix(0,M+1) 

P2 <- matrix(0,M+1) 
V2 <- matrix(0,M+1) 

A1 <- matrix(0,N1,N2)
B1 <- matrix(0,N1) 

for (i1 in 1:N1){
for (i2 in 1:N2){

Z = rpoispp(lambda) 
X <- cbind(Z$x,Z$y)
ll<-length(X)/2

if (ll==0) {A1[i1,i2]=0} else {
X <- X[1:(ll-1),];X <- rbind(X,c(0.5,0.5));ll<-length(X)/2

if (ll<=2) {A1[i1,i2]=0} else {
c <- voronoi.mosaic(X[,1],X[,2]);cc<-cells(c) 
l<-length(cc);lll=length(cc[[l]]$nodes)/2

if (lll<=2) A1[i1,i2]=0 else A1[i1,i2]=-1+length(X)/2-length(cc[[l]]$nodes)/2

}}
}}

for (n in 0:M){
for (i1 in 1:N1) B1[i1]=length(which(A1[i1,]==n))/N2
P1[n+1] = mean(B1)
V1[n+1] = var(B1)

print(c(n,P1[n+1],V1[n+1]))
}

for (n in 0:M){

A2 <- matrix(0,N1,N2)
B2 <- matrix(0,N1) 

for (i1 in 1:N1){
for (i2 in 1:N2){

Z = rpoispp(lambda);X <- cbind(Z$x,Z$y);ll<-length(X)/2

if (ll==0) {a=1} else {
X <- X[1:(ll-1),];X <- rbind(X,c(0.5,0.5))

if (ll<=2) {a=1} else {
c <- voronoi.mosaic(X[,1],X[,2]);cc<-cells(c) 
l<-length(cc);lll=length(cc[[l]]$nodes)/2

if (lll<=2) {a=1} else {

xxx <- matrix(0,(length(cc[[l]]$nodes)/2)) 
yyy <- matrix(0,(length(cc[[l]]$nodes)/2)) 

rr<-c()
for (i in 1:(length(cc[[l]]$nodes)/2))
{
rr=c(rr,sqrt((cc[[l]]$nodes[1,i]-0.5)^2+(cc[[l]]$nodes[2,i]-0.5)^2))
xxx[i]=cc[[l]]$nodes[1,i]
yyy[i]=cc[[l]]$nodes[2,i]
}

Z <- ppp(xxx,yyy, c(min(0,xxx),max(1,xxx)), c(min(0,yyy),max(1,yyy)))
a<-area(intersect.owin(unit.square(),discs(Z,radii= rr,mask = FALSE)))

}}}

A2[i1,i2]=(lambda*(1-a))^n*exp(-lambda*(1-a))
}}

for (i1 in 1:N1) B2[i1]=sum(A2[i1,])/N2/factorial(n)

P2[n+1] = mean(B2)
V2[n+1] = var(B2)

print(c(n,P1[n+1],V1[n+1]))
print(c(n,P2[n+1],V2[n+1]))

}

plot(P1,col="darkorange",xlab="n",cex=1.5,ylab="Probability p",axes=FALSE)
points(P2,col="blue",cex=1.5,pch=16) 
lines(P2,col="blue",lw=4) 
lines(P1,col="darkorange",lty=2, lw=4)
points(dpois( x=0:M, lambda ),col="red",lty=2, lw=4)
lines(dpois( x=0:M, lambda ),col="red",lty=2, lw=4)
legend("topright",legend=c("Sampling","Averaging",expression(paste("Poisson(",lambda,")"))),col=c("darkorange","blue","red"),lty=c(2,1,2),lw=3,cex=1.7)
# legend("topright",legend=c("sampling","averaging"),pch=c(1,1),col=c("darkorange","blue"))
axis(1,at=seq(1,M+1,1),labels=seq(0,M,1)) 
axis(2) 

